package org.hisrc.hifaces20.testing.server.testing;

import static org.junit.Assert.*;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hisrc.hifaces20.testing.server.WebServerEnvironment;
import org.hisrc.hifaces20.testing.server.WebServerEnvironmentFactory;
import org.hisrc.hifaces20.testing.server.jetty.PropertiesJettyWebServerEnvironmentFactory;
import org.junit.After;

public abstract class AbstractMultipleWebServerEnvironmentTest {

	protected final Log log = LogFactory.getLog(getClass());

	protected List<WebServerEnvironment> webServers = new ArrayList<WebServerEnvironment>();

	@After
	public void stopWebServers() throws IOException, Exception {
		log.debug("Stopping web servers begin...");
		for (WebServerEnvironment server : webServers) {
			stopWebServer(server);
		}
		log.debug("Stopping web servers end.");
	}

	protected WebServerEnvironment startWebServer(String propertiesFilePath)
			throws IOException, Exception {
		WebServerEnvironmentFactory factory = PropertiesJettyWebServerEnvironmentFactory
				.getInstance(new File("."), //$NON-NLS-1$
						propertiesFilePath);
		WebServerEnvironment webServerEnvironment = factory
				.createWebServerEnvironment();
		webServerEnvironment.start();
		assertTrue(webServerEnvironment.isStarted());
		webServers.add(webServerEnvironment);
		return webServerEnvironment;
	}

	protected void stopWebServer(WebServerEnvironment server)
			throws IOException, Exception {
		if (server != null && server.isStarted()) {
			server.stop();
		}
	}

}
