package org.hisrc.hifaces20.testing.server.testing;

import java.io.File;

import junit.framework.Assert;


import org.hisrc.hifaces20.testing.server.WebServerEnvironment;
import org.hisrc.hifaces20.testing.server.WebServerEnvironmentFactory;
import org.hisrc.hifaces20.testing.server.jetty.PropertiesJettyWebServerEnvironmentFactory;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;

public abstract class AbstractWebServerEnvironmentTest {

	public abstract String getPropertiesFileName();

	protected WebServerEnvironment webServerEnvironment;

	@Before
	public void start() throws Exception {
		final WebServerEnvironmentFactory factory = PropertiesJettyWebServerEnvironmentFactory
				.getInstance(new File("."), getPropertiesFileName());

		webServerEnvironment = factory.createWebServerEnvironment();

		webServerEnvironment.start();

	}

	@Test
	public void test() throws Exception {
		Assert.assertTrue(webServerEnvironment.isStarted());
	}

	@After
	public void stop() throws Exception {
		webServerEnvironment.stop();
	}
}
